local L = LibStub("AceLocale-3.0"):GetLocale("AVRE", false)
local AVRE = AVRE
if not AVRE or not AVR then return end
local mod = AVRE:NewModule("Icecrown", "AceConsole-3.0")
local zone = LibStub("AceLocale-3.0"):GetLocale("AVRE Zones")["Icecrown Citadel"]


function mod:OnInitialize()
	AVRE.modules.encounters.icecrown.loaded = true
end


function mod:OnEnable()
	DEFAULT_CHAT_FRAME:AddMessage(format(L["AVR Encounters (%s) loaded"], zone))
	
	AVRE:RegisterEncounters({
	
		
-- PUTRICIDE ----------------------------------------------------------------------------------------------------------

		putricide = {
			name = "Professor Putricide",
			zone = zone,
			pull = {
				type = "combat",
				npcs = { 36678, 37562, 37697 },
			},
			defeat = {
				type = "death",
				npcs = { 36678 },
			},
			
			onStart = function(self)
				self.unboundMeshes = {}
				self.unboundMeshes2 = {}
				self.sicknessMeshes = {}
			end,
			
			onEnd = function(self) end,
			
			combatEvents = {
				SPELL_CAST_SUCCESS = true,
				SPELL_AURA_APPLIED = true,
				SPELL_AURA_REMOVED = true,
			},

			onCombat = function(self, event, timestamp, eventType, srcGuid, srcName, srcFlags, dstGuid, dstName, dstFlags, spellId, spellName, spellSchool)
				if eventType == "SPELL_CAST_SUCCESS" then
				
					-- Malleable Goo
					if spellId == 72295 then
						self:Print("Malleable Goo cast")
						local target = AVRE:GetBossTarget(36678)
						if not target then return end
						AVR:AddCircleWarning(AVRE.scene, target, false, 5, 5)
					end
					
				elseif eventType == "SPELL_AURA_APPLIED" then
				
					-- Unbound Plague applied
					if spellId == 72855 or spellId == 72856 then
						local player = dstName
						local m = self.unboundMeshes[player]
						if m then m:Remove() end
						m = self.unboundMeshes2[player]
						if m then m:Remove() end
						
						_, _, _, _, _, duration, expirationTime = UnitDebuff(player, spellName)
						if not duration or not expirationTime then return end
						
						m = AVR:AddCircleWarning(AVRE.scene, player, true, 3, nil, 1, 0.5, 0, nil, nil, true)
						m:SetTimer(60, expirationTime)
						self.unboundMeshes[player] = m
						
						m = AVR:AddCircleWarning(AVRE.scene, player, true, 4, nil, 1, 0.5, 0, nil, nil, true)
						m:SetTimer(15)
						self.unboundMeshes2[player] = m	
					end
					
				elseif eventType == "SPELL_AURA_REMOVED" then
				
					-- Unbound Plague removed
					if spellId == 72855 or spellId == 72856 then
						local player = dstName
						local m = self.unboundMeshes[player]
						if m then 
							m:Remove()
							self.unboundMeshes[player] = nil
						end
						local m = self.unboundMeshes2[player]
						if m then 
							m:Remove()
							self.unboundMeshes2[player] = nil
						end
					end
					
				end
			end,
			
		},


-- ROTFACE ------------------------------------------------------------------------------------------------------------

		rotface = {
			name = "Rotface",
			zone = zone,
			pull = {
				type = "combat",
				npcs = { 36627 },
			},
			defeat = {
				type = "death",
				npcs = { 36627 },
			},
			
			onStart = function(self) end,
			onEnd = function(self) end,
			
			combatEvents = {
				SPELL_CAST_START = true,
			},
			
			onCombat = function(self, event, timestamp, eventType, srcGuid, srcName, srcFlags, dstGuid, dstName, dstFlags, spellId, spellName, spellSchool)
				-- Unstable Ooze Explosion
				if spellId == 69839 then
					AVR:AddCircleWarningEveryone(AVRE.scene, false, 6, 10, nil, nil, nil, 0.2, 10)
				end
			end,
		},
		
		
	})
	
end
